2011-07-31 18:37:50 +02:00
#!/bin/sh
2018-07-28 23:23:39 +02:00
# minimum required node version
2019-02-19 00:48:50 +01:00
REQUIRED_NODE_MAJOR = 8
2018-07-28 23:23:39 +02:00
REQUIRED_NODE_MINOR = 9
# minimum required npm version
2019-02-19 00:48:50 +01:00
REQUIRED_NPM_MAJOR = 6
REQUIRED_NPM_MINOR = 4
2018-07-28 23:23:39 +02:00
require_minimal_version( ) {
PROGRAM_LABEL = " $1 "
VERSION_STRING = " $2 "
REQUIRED_MAJOR = " $3 "
REQUIRED_MINOR = " $4 "
2018-07-31 12:44:17 +02:00
# Flag -s (--only-delimited on GNU cut) ensures no string is returned
# when there is no match
DETECTED_MAJOR = $( echo $VERSION_STRING | cut -s -d "." -f 1)
DETECTED_MINOR = $( echo $VERSION_STRING | cut -s -d "." -f 2)
2018-07-28 23:23:39 +02:00
if [ -z " $DETECTED_MAJOR " ] ; then
printf 'Cannot extract %s major version from version string "%s"\n' " $PROGRAM_LABEL " " $VERSION_STRING " >& 2
exit 1
fi
if [ -z " $DETECTED_MINOR " ] ; then
printf 'Cannot extract %s minor version from version string "%s"\n' " $PROGRAM_LABEL " " $VERSION_STRING " >& 2
exit 1
fi
case " $DETECTED_MAJOR " in
'' | *[ !0-9] *)
printf '%s major version from "%s" is not a number. Detected: "%s"\n' " $PROGRAM_LABEL " " $VERSION_STRING " " $DETECTED_MAJOR " >& 2
exit 1
; ;
esac
case " $DETECTED_MINOR " in
'' | *[ !0-9] *)
printf '%s minor version from "%s" is not a number. Detected: "%s"\n' " $PROGRAM_LABEL " " $VERSION_STRING " " $DETECTED_MINOR " >& 2
exit 1
esac
if [ " $DETECTED_MAJOR " -lt " $REQUIRED_MAJOR " ] || ( [ " $DETECTED_MAJOR " -eq " $REQUIRED_MAJOR " ] && [ " $DETECTED_MINOR " -lt " $REQUIRED_MINOR " ] ) ; then
printf 'Your %s version "%s" is too old. %s %d.%d.x or higher is required.\n' " $PROGRAM_LABEL " " $VERSION_STRING " " $PROGRAM_LABEL " " $REQUIRED_MAJOR " " $REQUIRED_MINOR " >& 2
exit 1
fi
}
2011-07-27 15:37:12 +02:00
#Move to the folder where ep-lite is installed
2011-08-03 23:08:27 +02:00
cd ` dirname $0 `
2011-07-27 15:37:12 +02:00
#Was this script started in the bin folder? if yes move out
if [ -d "../bin" ] ; then
cd "../"
fi
#Is node installed?
2017-09-14 13:33:27 +02:00
#Not checking io.js, default installation creates a symbolic link to node
2015-01-21 13:18:38 +01:00
hash node > /dev/null 2>& 1 || {
2017-09-14 13:33:27 +02:00
echo "Please install node.js ( https://nodejs.org )" >& 2
2015-01-21 13:18:38 +01:00
exit 1
2011-07-27 15:37:12 +02:00
}
#Is npm installed?
2015-01-21 13:18:38 +01:00
hash npm > /dev/null 2>& 1 || {
2017-09-14 13:33:27 +02:00
echo "Please install npm ( https://npmjs.org )" >& 2
2015-01-21 13:18:38 +01:00
exit 1
2011-07-27 15:37:12 +02:00
}
2017-09-14 13:33:27 +02:00
#Check npm version
2018-07-28 23:23:39 +02:00
NPM_VERSION_STRING = $( npm --version)
require_minimal_version "npm" " $NPM_VERSION_STRING " " $REQUIRED_NPM_MAJOR " " $REQUIRED_NPM_MINOR "
2011-08-11 16:09:05 +02:00
2017-09-14 13:33:27 +02:00
#Check node version
2018-07-28 23:23:39 +02:00
NODE_VERSION_STRING = $( node --version)
NODE_VERSION_STRING = ${ NODE_VERSION_STRING # "v" }
require_minimal_version "nodejs" " $NODE_VERSION_STRING " " $REQUIRED_NODE_MAJOR " " $REQUIRED_NODE_MINOR "
2012-01-26 12:55:54 +01:00
2012-02-21 20:20:45 +01:00
#Get the name of the settings file
settings = "settings.json"
a = '' ;
for arg in $* ; do
if [ " $a " = "--settings" ] || [ " $a " = "-s" ] ; then settings = $arg ; fi
a = $arg
done
2017-09-14 13:33:27 +02:00
#Does a $settings exist? if not copy the template
2012-02-21 20:20:45 +01:00
if [ ! -f $settings ] ; then
echo " Copy the settings template to $settings ... "
2012-11-07 12:51:51 +01:00
cp settings.json.template $settings || exit 1
2011-07-27 15:37:12 +02:00
fi
2013-02-10 04:17:04 +01:00
echo "Ensure that all dependencies are up to date... If this is the first time you have run Etherpad please be patient."
2012-02-26 13:31:47 +01:00
(
mkdir -p node_modules
cd node_modules
2012-02-26 13:54:32 +01:00
[ -e ep_etherpad-lite ] || ln -s ../src ep_etherpad-lite
cd ep_etherpad-lite
2018-07-14 17:54:26 +02:00
npm install --no-save --loglevel warn
2015-01-21 13:18:38 +01:00
) || {
2018-08-29 21:45:33 +02:00
rm -rf src/node_modules
2015-01-21 13:18:38 +01:00
exit 1
2011-08-09 12:14:09 +02:00
}
2011-07-27 15:37:12 +02:00
#Remove all minified data to force node creating it new
2015-04-04 17:30:41 +02:00
echo "Clearing minified cache..."
2011-07-27 15:37:12 +02:00
rm -f var/minified*
exit 0